option( BUILD_GROUND_PLOT "Build ground plotting library (for Kiva debugging only)" OFF )
mark_as_advanced(FORCE BUILD_GROUND_PLOT)

set(KIVA_TESTING ${BUILD_TESTING} CACHE BOOL "" FORCE)
set(KIVA_EXE_BUILD OFF CACHE BOOL "" FORCE)
set(KIVA_3D OFF CACHE BOOL "" FORCE)
set(KIVA_GROUND_PLOT ${BUILD_GROUND_PLOT} CACHE BOOL "" FORCE)
set(KIVA_COVERAGE OFF CACHE BOOL "" FORCE)

add_subdirectory("${CMAKE_SOURCE_DIR}/third_party/kiva-ep/")

include_directories("${kiva_SOURCE_DIR}/src")
include_directories("${kiva_SOURCE_DIR}/src/libkiva")
include_directories("${kiva_BINARY_DIR}/src/libkiva")
include_directories( SYSTEM "${kiva_SOURCE_DIR}/vendor/boost-1.61.0/")

if (BUILD_GROUND_PLOT)
  add_definitions("-DBOOST_ALL_NO_LIB")
  include_directories( SYSTEM "${kiva_SOURCE_DIR}/vendor/mathgl-2.3.5.1/include/")
  include_directories( SYSTEM "${kiva_BINARY_DIR}/vendor/mathgl-2.3.5.1/include/")
  add_subdirectory("${kiva_SOURCE_DIR}/vendor/zlib-1.2.8/")
  add_subdirectory("${kiva_SOURCE_DIR}/vendor/libpng-1.6.23/")
  add_subdirectory("${kiva_SOURCE_DIR}/vendor/mathgl-2.3.5.1/")
  add_subdirectory("${kiva_SOURCE_DIR}/vendor/boost-1.61.0/boost/filesystem/")
  add_subdirectory("${kiva_SOURCE_DIR}/vendor/boost-1.61.0/boost/system/")
  add_subdirectory("${kiva_SOURCE_DIR}/src/libgroundplot/")
endif()